/*-
 * Copyright (c) 2015 Weongyo Jeong <weongyo@3rocks.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

var g_check_current_ip = true;
var g_refresh_active_tab = false;

function restore_options() {
  chrome.storage.local.get({
    check_current_ip: true,
    refresh_active_tab: false,
  }, function (items) {
    g_check_current_ip = items.check_current_ip;
    g_refresh_active_tab = items.refresh_active_tab;
  });
}

function handle_options() {
  restore_options();
  $("#mudfish_conf_options").click(function () {
    if (chrome.runtime.openOptionsPage) {
      chrome.runtime.openOptionsPage();
    } else {
      window.open(chrome.runtime.getURL('html/options.html'));
    }
  });
}

function popup_disconnect_i18n() {
  var m;

  $("span[id^='i18n_']").each(function() {
    var id = $(this).attr("id");
    var message = chrome.i18n.getMessage(id);
    $("#" + id).html(message);
  });
  $("span[title]").each(function() {
    var titleAttr = $(this).attr("title");
    if (titleAttr && titleAttr.length > 0) {
      var translatedTitle = chrome.i18n.getMessage(titleAttr) || titleAttr;
      $(this).attr("title", translatedTitle);
    }
  });
  $("#staticnode_picked").html(chrome.i18n.getMessage("i18n_8524de963f07201e5c086830d370797f"));
}

$(document).ready(function () {
  popup_disconnect_i18n();
  handle_options();

  $("#disconnect_button").click(function () {
    chrome.runtime.sendMessage({
      type: 'DISCONNECT'
    }, function (resp) {
      chrome.action.setIcon({
        path: "/images/appIcon/default-icon-b.png"
      });
      chrome.action.setPopup({
        popup: "/html/popup_connect.html"
      });
      if (g_refresh_active_tab) {
        const queryInfo = {
          active: true,
          currentWindow: true
        };
        chrome.tabs.query(queryInfo, function (arrayOfTabs) {
          if (arrayOfTabs.length > 0) {
            chrome.tabs.reload(arrayOfTabs[0].id);
          }
        });
      }
      if (g_check_current_ip) {
        setTimeout(function () {
          chrome.tabs.create({ url: "https://myip.mudfish.net" });
        }, 50);
      } else {
        window.close();
      }
    });
  });
  chrome.runtime.sendMessage({
    type: 'GET_SERVER'
  }, function (response) {
    $("#staticnode_picked").html(response.location);
  });
});